<?php

namespace Wappointment\Controllers;

use Wappointment\Services\Client;
use Wappointment\Services\Appointment;
use Wappointment\Validators\HttpRequest\Booking;
use Wappointment\WP\Helpers as WPHelpers;
use Wappointment\ClassConnect\Request;
class BookingController extends \Wappointment\Controllers\RestController
{
    public function save(\Wappointment\Validators\HttpRequest\Booking $booking)
    {
        if ($booking->hasErrors()) {
            return \Wappointment\WP\Helpers::restError('Review your fields', 500, $booking->getErrors());
        }
        $result = \Wappointment\Services\Client::book($booking);
        if (isset($result['errors'])) {
            return \Wappointment\WP\Helpers::restError('Impossible to proceed with the booking', 500, $result['errors']);
        }
        return (new \WappoVendor\Illuminate\Support\Collection($result->toArray()))->except(['id', 'edit_key', 'client_id']);
    }
    public function reschedule(\Wappointment\ClassConnect\Request $request)
    {
        $result = \Wappointment\Services\Appointment::reschedule($request->input('appointmentkey'), $request->input('time'));
        /*         if ($result) {
                       return ['message' => 'Appointment has been rescheduled'];
                   } */
        return $result;
    }
}
