<?php

namespace Wappointment\Installation;

use Wappointment\Config\Database;
class Migrate extends \WappoVendor\Illuminate\Database\Migrations\Migration
{
    public $capsule;
    public $migrationRepo;
    public function __construct()
    {
        $this->capsule = \Wappointment\Config\Database::capsule();
        $this->migrationRepo = new \WappoVendor\Illuminate\Database\Migrations\DatabaseMigrationRepository($this->capsule->getDatabaseManager(), \Wappointment\Config\Database::$prefix_self . '_migrations');
        if (!$this->migrationRepo->repositoryExists()) {
            $this->migrationRepo->createRepository();
        }
    }
    public function migrate()
    {
        $filesys = new \WappoVendor\Illuminate\Filesystem\Filesystem();
        $migrator = new \WappoVendor\Illuminate\Database\Migrations\Migrator($this->migrationRepo, $this->capsule->getDatabaseManager(), $filesys);
        $migrator->run([WAPPOINTMENT_PATH . 'database' . \DIRECTORY_SEPARATOR . 'migrations']);
        $migrationCreator = new \WappoVendor\Illuminate\Database\Migrations\MigrationCreator($filesys);
    }
}
