<?php

namespace Wappointment\Messages;

use Wappointment\Models\Client;
use Wappointment\Models\Appointment;
use Wappointment\Services\Settings;
class AdminCanceledAppointmentEmail extends \Wappointment\Messages\AbstractAdminEmail
{
    protected $client = null;
    protected $appointment = null;
    public function loadEmail(\Wappointment\Models\Client $client, \Wappointment\Models\Appointment $appointment, $reminder_id = false)
    {
        $this->subject = 'Cancelled appointment';
        $this->addLogo();
        $this->addBr();
        $tz = \Wappointment\Services\Settings::getStaff('timezone');
        $this->addRoundedSquare(['<u>Cancelled appointment</u>', 'Date: ' . $appointment->start_at->setTimezone($tz)->format(\Wappointment\Services\Settings::get('date_format')), 'Time: ' . $appointment->start_at->setTimezone($tz)->format(\Wappointment\Services\Settings::get('time_format')) . ' - ' . $appointment->end_at->setTimezone($tz)->format(\Wappointment\Services\Settings::get('time_format')), 'Service: ' . \Wappointment\Services\Settings::get('service')['name'], "Client's name: " . $client->name, "Client's email: " . $client->email]);
    }
}
