<?php

namespace Wappointment\Messages;

use Wappointment\Models\Client;
use Wappointment\Models\Appointment;
use Wappointment\Services\Settings;
use Wappointment\WP\Helpers as WPHelpers;
class AdminPendingAppointmentEmail extends \Wappointment\Messages\AbstractAdminEmail
{
    protected $client = null;
    protected $appointment = null;
    public function loadEmail(\Wappointment\Models\Client $client, \Wappointment\Models\Appointment $appointment, $reminder_id = false)
    {
        $this->subject = 'Pending appointment';
        $this->addLogo();
        $this->addBr();
        $tz = \Wappointment\Services\Settings::getStaff('timezone');
        $this->addRoundedSquare(['Date: ' . $appointment->start_at->setTimezone($tz)->format(\Wappointment\Services\Settings::get('date_format')), 'Time: ' . $appointment->start_at->setTimezone($tz)->format(\Wappointment\Services\Settings::get('time_format')) . ' - ' . $appointment->end_at->setTimezone($tz)->format(\Wappointment\Services\Settings::get('time_format')), 'Service: ' . \Wappointment\Services\Settings::get('service')['name'], "Client's name: " . $client->name, "Client's email: " . $client->email]);
        $this->addBr();
        $formatString = 'Y-m-d\\T00:00:00';
        $st = $appointment->start_at->startOfWeek()->format($formatString);
        $end = $appointment->start_at->addDays(7)->format($formatString);
        $buttonConfirm = true;
        $buttonConfirm = apply_filters('wappointment_appointment_pending_email_button', $buttonConfirm, $appointment->options);
        if ($buttonConfirm === true) {
            $this->addButton('Confirm appointment', \Wappointment\WP\Helpers::adminUrl('wappointment_calendar&start=' . $st . '&end=' . $end . '&timezone=' . $tz . '&open_confirm=' . $appointment->id));
        } else {
            $this->addLines($buttonConfirm);
        }
    }
}
