<?php

namespace Wappointment\Services;

use Wappointment\Config\Database;
use Wappointment\WP\Helpers as WPHelpers;
use Wappointment\System\Installation;
use Wappointment\WP\Scheduler as WPScheduler;
class Reset
{
    public function __construct()
    {
        $this->removeStaffSettings();
        $this->dropTables();
        $this->removeCoreSettings();
        \Wappointment\WP\Scheduler::clearScheduler();
        //$this->reInstallApplication();
    }
    private function removeStaffSettings()
    {
        foreach (\Wappointment\Services\Staff::getIds() as $staff_id) {
            \Wappointment\Services\Settings::deleteStaff($staff_id);
            \Wappointment\WP\Helpers::deleteStaffOption('availability', $staff_id);
            \Wappointment\WP\Helpers::deleteStaffOption('last-calendar-id', $staff_id);
            \Wappointment\WP\Helpers::deleteStaffOption('last-calendar-checked', $staff_id);
            \Wappointment\WP\Helpers::deleteStaffOption('last-calendar-parsed', $staff_id);
        }
    }
    private function dropTables()
    {
        \WappoVendor\Illuminate\Database\Capsule\Manager::schema()->dropIfExists(\Wappointment\Config\Database::$prefix_self . '_appointments');
        \WappoVendor\Illuminate\Database\Capsule\Manager::schema()->dropIfExists(\Wappointment\Config\Database::$prefix_self . '_statuses');
        \WappoVendor\Illuminate\Database\Capsule\Manager::schema()->dropIfExists(\Wappointment\Config\Database::$prefix_self . '_reminders');
        \WappoVendor\Illuminate\Database\Capsule\Manager::schema()->dropIfExists(\Wappointment\Config\Database::$prefix_self . '_clients');
        \WappoVendor\Illuminate\Database\Capsule\Manager::schema()->dropIfExists(\Wappointment\Config\Database::$prefix_self . '_jobs');
        \WappoVendor\Illuminate\Database\Capsule\Manager::schema()->dropIfExists(\Wappointment\Config\Database::$prefix_self . '_failed_jobs');
        \WappoVendor\Illuminate\Database\Capsule\Manager::schema()->dropIfExists(\Wappointment\Config\Database::$prefix_self . '_logs');
        \WappoVendor\Illuminate\Database\Capsule\Manager::schema()->dropIfExists(\Wappointment\Config\Database::$prefix_self . '_migrations');
    }
    private function removeCoreSettings()
    {
        \Wappointment\WP\Helpers::deleteOption('wizard_step');
        \Wappointment\WP\Helpers::deleteOption('subscribed_status');
        \Wappointment\WP\Helpers::deleteOption('widget_settings');
        \Wappointment\WP\Helpers::deleteOption('site_details');
        \Wappointment\WP\Helpers::deleteOption('site_key');
        \Wappointment\WP\Helpers::deleteOption('installation_completed');
        \Wappointment\WP\Helpers::deleteOption('installation_step');
        \Wappointment\Services\Settings::delete();
    }
    private function reInstallApplication()
    {
        new \Wappointment\System\Installation();
    }
}
