<?php

declare (strict_types=1);
namespace WappoVendor\Achse\Math\Interval\DateTimeImmutable;

use WappoVendor\Achse\Comparable\ComparisonMethods;
use WappoVendor\Achse\Comparable\IComparable;
use WappoVendor\Achse\Math\Interval\Utils;
use DateTimeInterface;
final class DateTimeImmutable extends \DateTimeImmutable implements \WappoVendor\Achse\Comparable\IComparable
{
    use ComparisonMethods;
    /**
     * @param DateTimeInterface $dateTime
     * @return static
     */
    public static function from(\DateTimeInterface $dateTime) : \WappoVendor\Achse\Math\Interval\DateTimeImmutable\DateTimeImmutable
    {
        return new static($dateTime->format('Y-m-d H:i:s.u'), $dateTime->getTimezone());
    }
    /**
     * @inheritdoc
     */
    public function compare(\WappoVendor\Achse\Comparable\IComparable $other) : int
    {
        /** @var static $other */
        \WappoVendor\Achse\Math\Interval\Utils::validateClassType(static::class, $other);
        return \WappoVendor\Achse\Math\Interval\Utils::numberCmp($this->getTimestamp(), $other->getTimestamp());
    }
    /**
     * @return string
     */
    public function __toString() : string
    {
        return $this->format(\DateTime::ATOM);
    }
}
