<?php

declare (strict_types=1);
namespace WappoVendor\Achse\Math\Interval\SingleDayTime;

use WappoVendor\Achse\Math\Interval\Boundary;
use WappoVendor\Achse\Math\Interval\Interval;
use WappoVendor\Achse\Math\Interval\IntervalStringParser;
final class SingleDayTimeIntervalStringParser extends \WappoVendor\Achse\Math\Interval\IntervalStringParser
{
    /**
     * @param string $string
     * @return SingleDayTimeInterval
     */
    public static function parse(string $string) : \WappoVendor\Achse\Math\Interval\Interval
    {
        list($left, $right) = self::parseBoundariesStringsFromString($string);
        return new \WappoVendor\Achse\Math\Interval\SingleDayTime\SingleDayTimeInterval(self::parseBoundary($left), self::parseBoundary($right));
    }
    /**
     * @param string $string
     * @return SingleDayTimeBoundary
     */
    protected static function parseBoundary(string $input) : \WappoVendor\Achse\Math\Interval\Boundary
    {
        list($elementString, $state) = self::parseBoundaryDataFromString($input);
        return new \WappoVendor\Achse\Math\Interval\SingleDayTime\SingleDayTimeBoundary(\WappoVendor\Achse\Math\Interval\SingleDayTime\SingleDayTime::from($elementString), $state);
    }
}
