<?php

namespace WappoVendor\Illuminate\Database\Eloquent\Relations;

use WappoVendor\Illuminate\Database\Eloquent\Collection;
class HasMany extends \WappoVendor\Illuminate\Database\Eloquent\Relations\HasOneOrMany
{
    /**
     * Get the results of the relationship.
     *
     * @return mixed
     */
    public function getResults()
    {
        return $this->query->get();
    }
    /**
     * Initialize the relation on a set of models.
     *
     * @param  array   $models
     * @param  string  $relation
     * @return array
     */
    public function initRelation(array $models, $relation)
    {
        foreach ($models as $model) {
            $model->setRelation($relation, $this->related->newCollection());
        }
        return $models;
    }
    /**
     * Match the eagerly loaded results to their parents.
     *
     * @param  array   $models
     * @param  \Illuminate\Database\Eloquent\Collection  $results
     * @param  string  $relation
     * @return array
     */
    public function match(array $models, \WappoVendor\Illuminate\Database\Eloquent\Collection $results, $relation)
    {
        return $this->matchMany($models, $results, $relation);
    }
}
